import es
import playerlib
import gamethread

import wcs
from wcs import wcs

Name   = 'Puss-N-Boots'
race   = wcs.Race(Name)
weapon = 'knife'

race.registerAuthor('||Wolf||')
race.registerWeaponRestriction('allow only', weapon)

####################
config = race.config()
text   = race.loadStrings()


config.addComment('********************')
config.addComment('Fencing')
config.addComment(' You learn how to use your sword.')
config.addComment('********************')
config.addComment()

swordMaxLevel      = config.addVar('swordMaxLevel',     10, 'Max Level')
swordLevelInterval = config.addVar('swordLevelInterval', 1, 'Level Interval')
swordDamage        = config.addVar('swordDamage',      0.3, 'Sword Damage Per Level')

config.addComment('********************')
config.addComment('Agility')
config.addComment(' Learn how to be more agile.')
config.addComment('********************')
config.addComment()

speedMaxLevel      = config.addVar('speedMaxLevel',     10, 'Max Level')
speedLevelInterval = config.addVar('speedLevelInterval', 1, 'Level Interval')
speedAmount        = config.addVar('speedAmount',     0.04, 'Speed Amount Per Level')

config.addComment('********************')
config.addComment('Pounce')
config.addComment(' Jump further.')
config.addComment('********************')
config.addComment()

pounceMaxLevel      = config.addVar('pounceMaxLevel',     10, 'Max Level')
pounceLevelInterval = config.addVar('pounceLevelInterval', 1, 'Level Interval')

config.load(True)
####################

race.registerSkill('Fencing', int(swordMaxLevel),  int(swordLevelInterval),  'You learn how to use your sword.')
race.registerSkill('Agility', int(speedMaxLevel),  int(speedLevelInterval),  'Learn how to be more agile.')
race.registerSkill('Pounce',  int(pounceMaxLevel), int(pounceLevelInterval), 'Jump further.')



def player_spawn(ev):
    userid = ev['userid']

    if wcs.GetRace(userid) == Name:   
        playerlib.getPlayer(userid).set('model', 'models/player/techknow/puss/puss.mdl')
        
        agility = wcs.GetLevel(userid, Name, 'Aility')
        speed   = float(agility * speedAmount)
        if agility:
            wcs.Command(userid).SpeedAdd(speed)
            es.tell(userid,'#multi','#greenAgility #default- #lightgreenYou can now move more quickly.')

def player_hurt(ev):
    userid   = ev['userid']
    attacker = ev['attacker']
    damage   = int(ev['dmg_health'])

    sword = wcs.GetLevel(attacker, Name, 'Fencing')
    sDamage = float(sword * swordDamage)
    if sword:
        wcs.Command(userid).Damage(damage * sDamage, 4, attacker)
        es.tell(attacker, '#multi', '#greenFencing #default- #lightgreenYou have done \'#green%s#lightgreen\' extra damage.' %(damage * sDamage))
        
def player_jump(ev):
    userid = ev['userid']
    
    pounce = wcs.GetLevel(userid, Name, 'Pounce')
    if pounce:
        vec1   = es.getplayerprop(userid,'CBasePlayer.localdata.m_vecVelocity[0]')
        vec2   = es.getplayerprop(userid,'CBasePlayer.localdata.m_vecVelocity[1]')
        vec3   = es.getplayerprop(userid,'CBasePlayer.localdata.m_vecVelocity[2]')
        vec1   = ((pounce / 2 ) * vec1) * (1 / 4.1)
        vec2   = ((pounce / 2 ) * vec2) * (1 / 4.1)
        vec3   = wcs.Command(userid).Push(vec1 * 2,vec2 * 2,(pounce / 2) * 45)
        vector = es.createvectorstring(vec1,vec2,vec3 + 10)
        
        es.setplayerprop(userid,'CBasePlayer.localdata.m_vecBaseVelocity',vector)
